import os

__all__ = ['Viper', 'plot', 'update', 'interactive', 'save_plot', 'figure']

if os.environ.has_key('DOLFIN_NOPLOT'):
    from dolfin import File

    def ignore(*args, **kwargs):
        pass
    for x in __all__:
        exec('%s = ignore' % x)

    # Override some functions, to save plot data for regression testing
    n=0
    def plot(u, *args, **kwargs):
        global n
        n += 1
        file = File('plot-output-%d.pvd' % n)
        file << u

else:
    try:
        for x in __all__:
            exec ('from viper.viper_dolfin import %s' % x)
    except:
        def no_viper(*args, **kwargs):
            raise RuntimeError, "Unable to plot (Viper plotter not available)"
        for x in __all__:
            exec('%s = no_viper' % x)
